program matrix_einlesen
  implicit none

  integer :: ioopen, i, j, k
  character, dimension(:,:), allocatable :: m

  !Gegebene Datei oeffnen, um daraus zu lesen:
  open(unit=31, file='U11_Block.dat', status='old', action='read', iostat=ioopen)
  if (ioopen==0) then
    read(31,*) i, j
    allocate(m(i,j))
    do k=1, i, 1
      read(31,*) m(k,:)
    end do
    !Neue Datei erstellen, in die geschrieben werden soll:
    open(unit=32, file='neue_datei.dat', status='replace', action='write', iostat=ioopen)
    if (ioopen==0) then
      do k=1, j, 1
        write(32,*) m(:,k) !Schreiben in die Datei (spaltenweise als Matrix)
        write(*,*) m(:,k)  !Ausgeben auf Bildschirm (spaltenweise als Matrix)
      end do
      write(*,*)
      write(*,*) m  !Ausgeben auf Bildschirm (spaltenweise hinter einander weg)
      close(31)
      close(32)
    else
      write(*,*) 'Error, cannot open file 32'
    end if
    deallocate(m)
  else
    write(*,*) 'Error, cannot open file 31'
  end if

end program
