program PointerListProgramm
    implicit none

    type:: ListElement
        character(len=20):: name = ""
        type(Listelement), pointer:: next => null()
    end type ListElement  

    type(ListElement), pointer   :: firstPerson  
    character(20)                :: name

    firstPerson => null()

    write(*,*) length(firstPerson)
    name = "Harry"
    call addPerson(firstPerson, name)
    name = "Hermine"
    call addPerson(firstPerson, name)
    write(*,*)firstPerson%name, length(firstPerson)

    call deletePerson(firstPerson)
    call deletePerson(firstPerson)

    write(*,*) length(firstPerson)
    call addPerson(firstPerson, name)
    write(*,*)firstPerson%name, length(firstPerson)
    call deletePerson(firstPerson)

    contains
        subroutine addPerson (firstPerson, name)
            type(ListElement), pointer      :: firstPerson
            character(len=20), intent(in)   :: name
            type(ListElement), pointer      :: current
            
            if(.not.associated(firstPerson)) then
                allocate(firstPerson)
                firstPerson%name = name

            else
                current => firstPerson

                do while(associated(current%next))
                    current => current%next
                end do

                allocate(current%next)
                current%next%name = name
            end if
        endsubroutine addPerson

        function length(firstPerson)
            type(ListElement), pointer  :: firstPerson
            integer                     :: length
            type(ListElement), pointer  :: current

            if(.not.associated(firstPerson)) then
                length = 0
            else
                current => firstPerson
                length = 1
                do while(associated(current%next))
                    current => current%next
                    length = length + 1
                end do   
            end if
        end function

        subroutine deletePerson(firstPerson)
            type(ListElement), pointer,     :: firstPerson
            type(ListElement), pointer      :: current

            
            if(associated(firstPerson)) then ! Fall mind. 1 Element
                current => firstPerson

                if(associated(current%next)) then ! mehr als 1 Element
                    do while(associated(current%next%next))
                        current => current%next
                    end do

                    deallocate(current%next)
                else                                ! genau 1 Element
                    deallocate(firstPerson)
                end if
            end if
        end subroutine

end program PointerListProgramm
